unit Gist;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, TeeProcs, TeEngine, Chart, Buttons, Math,Menus,
  Series,
  //  LASDK
  ADC_Const, IADCDevice, IFactory, DllClient, VT_Drivers, ADC_Errors,
   CheckLst, Mask;

type
    Fon = record
       Nfon: SmallInt;                               // 2 byte
       Comm: string[79];                             // 
       Date : array[1..4] of SmallInt;               // 8
       Time : array[1..4] of SmallInt;               // 8
       freq: integer;                                //  
       FGain : array [1..4] of SmallInt;             //  
       Level : array [1..4] of SmallInt;             //     
       Delta : SmallInt;                             //   
       Fon1, Fon2, Fon3, Fon4: array[1..600] of Integer; //
       TimF : array[1..600, 1..4] of word; // 1   
       spectr1, spectr2, spectr3, spectr4 : array [1..256] of SmallInt;
    end;
    
    TFormBorderStyle = (bsNone, bsSingle, bsSizeable, bsDialog, bsToolWindow, bsSizeToolWin);
    TForm2 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Chart2: TChart;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    CloseButton: TMenuItem;
    Chan1: TMenuItem;
    Chan2: TMenuItem;
    Chan3: TMenuItem;
    Chan4: TMenuItem;

    N4: TMenuItem;
    Series1: TBarSeries;
    Label4: TLabel;
    Label6: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    N3: TMenuItem;
    bIntegr: TMenuItem;
    bCentre: TMenuItem;
    bStopInt: TButton;
    Series2: TLineSeries;
    procedure CloseButtonClick(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure Chan1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure chann1;
    procedure chann2;
    procedure chann3;
    procedure chann4;
    procedure Chan2Click(Sender: TObject);
    procedure Chan3Click(Sender: TObject);
    procedure Chan4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure bIntegrClick(Sender: TObject);
    procedure MNK(const XX, YY : array of Single; N : integer; var a, b : single);
    procedure bStopIntClick(Sender: TObject);
    procedure bCentreClick(Sender: TObject);

  private
    XX, YY, IntSpecLog : array[1..256] of Single;
    chkadr, NRecF: integer;
    Delta : SmallInt;
    RecF: Fon;
    FFon: file of Fon;
    BatN : SmallInt;
    Spectr : array [1..256] of SmallInt;
    z : SmallInt;
    { Private declarations }
  public
    NameF : string;
    BorderStyle:TFormBorderStyle;
    { Public declarations }
  end;

var
  Form2: TForm2;
implementation

uses VFonPCI2;

{$R *.dfm}


procedure TForm2.CloseButtonClick(Sender: TObject);  //  Close
begin
   bStopInt.Visible := false;
   Button3.Visible := true;
   Button2.Visible := true;
   Chart2.Series[1].Clear;
   Chart2.Series[0].Clear;
   Chart2.BottomAxis.Maximum := 255;
   Chart2.BottomAxis.Logarithmic := false;
   Chart2.LeftAxis.Automatic := true;
   Chart2.LeftAxis.Logarithmic := false;
   Chart2.RightAxis.Automatic := false;
   Chart2.RightAxis.Logarithmic := false;
   Chart2.Series[0].SeriesColor := clGreen;
   //Form1.bForm2.Visible := false; //   
   Form1.Gistr := false;          //    false
   Close();                       // 
end;

procedure TForm2.N2Click(Sender: TObject); //   
var   Left,right,x : integer;
begin
   Label1.caption := ' '+IntToStr(BatN); //  
   Chart2.Series[0].clear;          //  
   Left := StrToInt(trim(Edit1.Text));   //      
   Right := StrToInt(trim(Edit2.Text));  //      
   AssignFile(FFon,Form1.FName);      //   FName    
   Reset(FFon);
   Seek(FFon,NRecF);
   Read(FFon,RecF);
   chkadr := FileSize(FFon);      //   
   CloseFile(FFon);
   for x := Left to Right do  //  .
     Chart2.Series[0].AddXY(x,spectr[x],'',Chart2.Series[0].SeriesColor);
     
end;


procedure TForm2.Chan1Click(Sender: TObject); //    1
var
   i,x : integer;
   st1 : string;
begin
  { chart2.Series[0].Clear;
   chart2.series[1].Clear;
   //FName := FileList[ListBox1.ItemIndex + 1];
   AssignFile(FFon,Form1.FName);      //  
   Reset(FFon); NrecF := 0;
   Read(FFon,RecF);
   chkadr := FileSize(FFon);
   CloseFile(FFon);
   Form1.Skadr.Caption := IntToStr(chkadr);
   St1 := IntToStr(RecF.Time[1]) + ':';
   St1 := St1 + IntToStr(RecF.Time[2]) + ':';
   St1 := St1 + IntToStr(RecF.Time[3]);
   Form1.Label8.Caption := St1;   //   
   St1 := IntToStr(RecF.Date[3]) + '-';
   St1 := St1 + IntToStr(RecF.Date[2]) + '-';
   St1 := St1 + IntToStr(RecF.Date[1]);
   Form1.Label4.Caption := St1;   //   
   Form1.bGain2.Caption := IntToStr(RecF.Gain1);
   Form1.MaskEdit1.Text := IntToStr(RecF.Level);
   st1:='';
   for x := 1 to 6 do
       st1 :=st1+' '+ IntToStr(RecF.Gain[x]);
   Form1.eComment.Text:= St1;
   Delta := RecF.Delta;}
   Chart2.series[0].clear;
   BatN := 1;
   Label1.caption := ' '+IntToStr(BatN); //  
   NRecF := 0;                        //    
   AssignFile(FFon,NameF);      //  
   Reset(FFon);
   Read(FFon,RecF);
   Seek(FFon,NRecF);
   chkadr := FileSize(FFon);          //   
   CloseFile(FFon);
   for i := 1 to 256 do                 //  
       begin
           spectr[i] := RecF.spectr1[i];
           Chart2.Series[0].AddXY(i,spectr[i],'',Chart2.Series[0].SeriesColor);
       end;

end;

procedure TForm2.FormCreate(Sender: TObject);
var i : integer;
begin
    BatN := 1;          //      
   {NRecF := 0;
   AssignFile(FFon,Form1.FName);      //  
   Reset(FFon);
   Read(FFon,RecF);
   chkadr := FileSize(FFon);
   CloseFile(FFon);
    for i := 1 to 256 do
       spectr[i] := RecF.spectr1[i]; }
end;

procedure TForm2.chann1;     //   1  BatN = 1
var x: integer;
begin
    //Form1.Stroika := 1;
    AssignFile(FFon,Form1.FName);Reset(FFon);Seek(FFon,NrecF); //,, 
    Read(FFon,RecF);
    for x := 1 to 256 do       // . 
       spectr[x] := RecF.spectr1[x];
    CloseFile(FFon);
end;

procedure TForm2.chann2;     //   2  BatN = 2
var x: integer;
begin
    AssignFile(FFon,Form1.FName);Reset(FFon);Seek(FFon,NrecF); //,, 
    Read(FFon,RecF);
    for x := 1 to 256 do      // . 
       spectr[x] := RecF.spectr2[x];
    CloseFile(FFon);
end;

procedure TForm2.chann3;    //   3 BatN = 3
var x: integer;
begin
    AssignFile(FFon,Form1.FName);Reset(FFon);Seek(FFon,NrecF);  //,, 
    Read(FFon,RecF);
    for x := 1 to 256 do      // . 
       spectr[x] := RecF.spectr3[x];
    CloseFile(FFon);
    //a:=9;
    //form2.label1.caption := IntToStr(a);
end;

procedure TForm2.chann4;    //   4  BatN = 4
var x: integer;
begin
    AssignFile(FFon,Form1.FName);Reset(FFon);Seek(FFon,NrecF);//,, 
    Read(FFon,RecF);
    for x := 1 to 256 do       //  . 
       spectr[x] := RecF.spectr4[x];
    CloseFile(FFon);
    //a:=9;
    //form2.label1.caption := IntToStr(a);
end;


procedure TForm2.Button3Click(Sender: TObject);   //   
var i,x : integer;
begin
    Form1.KadrN.Caption := '';
                if NRecF >= chkadr - 1 then begin  //    
                Form1.KadrN.Caption := IntToStr(chkadr); Exit; end; //  
                inc(NRecF); //  
    Chart2.Series[0].Clear;
    case BatN of
          1 : chann1;
          2 : chann2;
          3 : chann3;
          4 : chann4;
      end;
            //  
    Form2.Label4.Caption := IntToStr(RecF.Date[3]) + '-' + IntToStr(RecF.Date[2])
                             + '-' + IntToStr(RecF.Date[1]);
    Form2.Label6.Caption := IntToStr(RecF.Time[1]) + ':' + IntToStr(RecF.Time[2])
                            + ':' + IntToStr(RecF.Time[3]);
    Label7.Caption :=  IntToStr(RecF.Nfon);
    //TForm1.bForm2;
    for x := StrToInt(trim(Edit1.Text)) to StrToInt(trim(Edit2.Text)) do  //  .
        Chart2.Series[0].AddXY(x,spectr[x],'',Chart2.Series[0].SeriesColor);
end;

procedure TForm2.Chan2Click(Sender: TObject);  //   2 
var i : SmallInt;
begin
   Chart2.Series[0].Clear;   // 
   BatN := 2;
   Label1.caption := ' '+IntToStr(BatN);
   NRecF := 0;
   AssignFile(FFon,Form1.FName);      //  
   Reset(FFon);
   Read(FFon,RecF);
   chkadr := FileSize(FFon);          //   
   CloseFile(FFon);
   for i := 1 to 256 do           //     .   
       begin
          spectr[i] := RecF.spectr2[i];
          Chart2.Series[0].AddXY(i,spectr[i],'',Chart2.Series[0].SeriesColor);
       end;
end;

procedure TForm2.Chan3Click(Sender: TObject);  //   3 
var i : SmallInt;
begin
   Chart2.Series[0].Clear;
   BatN := 3;
   Label1.caption := ' '+IntToStr(BatN);
   NRecF := 0;
   AssignFile(FFon,Form1.FName);      //  
   Reset(FFon);
   Read(FFon,RecF);
   chkadr := FileSize(FFon);          //   
   CloseFile(FFon);
   for i := 1 to 256 do      //     .   
       begin
          spectr[i] := RecF.spectr3[i];
          Chart2.Series[0].AddXY(i,spectr[i],'',Chart2.Series[0].SeriesColor);
       end;
end;

procedure TForm2.Chan4Click(Sender: TObject); //    4
var i : SmallInt;
begin
   Chart2.Series[0].Clear;
   BatN := 4;
   Label1.caption := ' '+IntToStr(BatN);
   NRecF := 0;
   AssignFile(FFon,Form1.FName);      //  
   Reset(FFon);
   Read(FFon,RecF);
   chkadr := FileSize(FFon);          //   
   CloseFile(FFon);
   for i := 1 to 256 do          //     .   
       begin
          spectr[i] := RecF.spectr4[i];
          Chart2.Series[0].AddXY(i,spectr[i],'',Chart2.Series[0].SeriesColor);
       end;
end;


procedure TForm2.Button2Click(Sender: TObject);  //    
var x : SmallInt;
begin

    if NRecF < 1 then begin   //    1-   
         Form1.KadrN.Caption := '1'; Exit; end; //  
    dec(NRecF);   //   
    Chart2.Series[0].Clear;
    case BatN of
          1 : chann1;
          2 : chann2;
          3 : chann3;
          4 : chann4;
      end;
            //  
    Form2.Label4.Caption := IntToStr(RecF.Date[3]) + '-' + IntToStr(RecF.Date[2])
                             + '-' + IntToStr(RecF.Date[1]);
    Form2.Label6.Caption := IntToStr(RecF.Time[1]) + ':' + IntToStr(RecF.Time[2])
                            + ':' + IntToStr(RecF.Time[3]);
    Label7.Caption :=  IntToStr(RecF.Nfon);   //  
    for x := StrToInt(trim(Edit1.Text)) to StrToInt(trim(Edit2.Text)) do  //  .
        Chart2.Series[0].AddXY(x,spectr[x],'',Chart2.Series[0].SeriesColor);

end;

procedure TForm2.bIntegrClick(Sender: TObject);
var s, i, i1, i2, l, r,zzz  : integer;
    max, max09, max01, a, b, y1, y2 : Single;
    sti, st1, st2 : string;
    Inspector,IntSpec : array [1..256] of Integer;

begin
  bStopInt.Visible := true;
  Button3.Visible := false;
  Button2.Visible := false;
  chart2.LeftAxis.Title.Caption := ''; //    OY
  for s := 1 to 256 do IntSpec[s] := 0;
  Chart2.Series[0].Clear;
  chart2.series[1].Clear;
 // chart2.series[2].clear;
  Form1.Memo1.lines.Clear;
  l := StrToInt(Edit1.Text);  //   
  r := StrToInt(Edit2.Text); //   
  i2 := r; //    
  for s := 1 to 256 do
      Inspector[s] :=0;
 { for s := l to i2-2 do begin  //      
 //     Inspector[s] := Inspector[s-1] + spectr[i2-s];
        IntSpec[i2-s -1] := IntSpec[i2-s] + spectr[i2-s];
        form2.Chart2.Series[0].AddXY(i2 - s,IntSpec[i2 - s],'',Chart2.Series[0].SeriesColor);
  end;}
   for s := l to r - 45 do       // ????? ????????? ??????? - ??? ????? ????????
      if spectr[s] > max then begin
         max := spectr[s]; i := s; end;
  for s := l to i2-2 do begin  // ???????????? ? ????? ????????????? ???????
       IntSpec[i2 - 1 - s] := IntSpec[i2 - s] + Round((spectr[i2 - s]/max)*100);
       Chart2.Series[0].AddXY(r - s,IntSpec[r - s],'',Chart2.Series[0].SeriesColor);
  end;

{  for j := 0 to 255 do
    begin
        IntSpec[j] := Inspector[s];
        s := s - 1;
        if s <= l then s :=l;
    end; }
  for s := 1 to 256 do begin  //   256 
       Str(s:4,sti);Str(spectr[s]:5,st1);Str(IntSpec[s]:9,st2);
       Form1.Memo1.Lines.Add(sti+': '+st1+st2);
    end;

  for s := l to r do   //      
    IntSpecLog[s] := log10(IntSpec[s] + 1);
  max := 0;
  for s := l to r - 45 do       //     -   
      if spectr[s] > max then begin
         max := spectr[s]; i := s; end;
  max := IntSpecLog[i - 1];
  max09 := 0.8 * max;   //    Y  
  max01 := 0.4 * max;
  for s := i to r do begin    //   X  
     if IntSpecLog[s] >= max09 then i1 := s;
     if IntSpecLog[s] > max01 then i2 := s;
  end;
  i := 0;
  for s := i1 to i2 do begin    //    
     XX[s - i1 + 1] := log10(s);
     YY[s - i1 + 1] := IntSpecLog[s];
  end;
  MNK(XX, YY, i2-i1, a, b);  //   
  form2.Chart2.Series[1].Clear;       //      
  form2.Chart2.Series[0].Clear;
  form2.Chart2.BottomAxis.Maximum := 255;
  form2.Chart2.BottomAxis.Logarithmic := true;
  form2.Chart2.LeftAxis.Automatic := true;
  form2.Chart2.LeftAxis.Logarithmic := true;
  form2.Chart2.RightAxis.Automatic := true;
  form2.Chart2.RightAxis.Logarithmic := true;
  form2.Chart2.Series[0].SeriesColor := clSilver;
  for s := 1 to 255 do begin  //  . 
    form2.Chart2.Series[0].AddXY(s,IntSpec[s],'',Chart2.Series[0].SeriesColor);
   // Chart2.Series[0].AddXY(s,RecL.ClbData1[s],'',Chart2.Series[0].SeriesColor);
  end;
  y1 := b * log10(i1) + a; y1 := exp(Ln(10)*y1);  // .  . 
  y2 := b * log10(i2) + a; y2 := exp(Ln(10)*y2);
  form2.Chart2.Series[1].AddXY(i1,y1,'',Chart2.Series[1].SeriesColor);
  form2.Chart2.Series[1].AddXY(i2,y2,'',Chart2.Series[1].SeriesColor);
  Str(b:5:2,st1); Str(a:5:2,st2);  //   a  b
  form2.Label6.Caption := 'b = ' + st1 + '   ' + 'a = ' + st2;
 end;


procedure TForm2.MNK(const XX, YY : array of Single; N : integer; var a, b : single);// ????? ?????????? ?????????
var
    PP : Double;
    QQ : Double;
    PQ : Double;
    b1 : Double;
    b2 : Double;
    d1 : Double;
    d2 : Double;
    t1 : Double;
    t2 : Double;
    Phi : Double;
    c : Double;
    s : Double;
    m : Double;
    I : Integer;
begin
    PP := N;
    QQ := 0;
    PQ := 0;
    b1 := 0;
    b2 := 0;
    I:=0;
    while I<=N-1 do
    begin
        PQ := PQ+XX[I];
        QQ := QQ+Sqr(XX[I]);
        b1 := B1+YY[I];
        b2 := B2+XX[I]*YY[I];
        Inc(I);
    end;
    Phi := ArcTan2(2*PQ, QQ-PP)/2;
    c := Cos(Phi);
    s := Sin(Phi);
    d1 := Sqr(c)*pp+Sqr(s)*qq-2*s*c*pq;
    d2 := Sqr(s)*pp+Sqr(c)*qq+2*s*c*pq;
    if Abs(d1)>Abs(d2) then
    begin
        m := Abs(d1);
    end
    else
    begin
        m := Abs(d2);
    end;
    t1 := c*b1-s*b2;
    t2 := s*b1+c*b2;
    if Abs(d1)>m*5.0*10e-324*1000 then
    begin
        t1 := t1/d1;
    end
    else
    begin
        t1 := 0;
    end;
    if Abs(d2)>m*5.0*10e-324*1000 then
    begin
        t2 := t2/d2;
    end
    else
    begin
        t2 := 0;
    end;
    a := c*t1+s*t2;
    b := -s*t1+c*t2;
end;

procedure TForm2.bStopIntClick(Sender: TObject);
begin
   bStopInt.Visible := false;
   Button3.Visible := true;
   Button2.Visible := true;
   Chart2.Series[1].Clear;
   Chart2.Series[0].Clear;
   Chart2.BottomAxis.Maximum := 255;
   Chart2.BottomAxis.Logarithmic := false;
   Chart2.LeftAxis.Automatic := true;
   Chart2.LeftAxis.Logarithmic := false;
   Chart2.RightAxis.Automatic := false;
   Chart2.RightAxis.Logarithmic := false;
   Chart2.Series[0].SeriesColor := clGreen;
end;



procedure TForm2.bCentreClick(Sender: TObject);
 var s, i, i1, i2, l, r,interval,rr,li,ri  : integer;
    max, plosh, max01, a, b, y1, y2 : Single;
    pl, KoObr : real;
    sti, st1, st2 : string;
    HMassiv : array [1..256] of SmallInt;
 Begin
     Chart2.Series[0].clear;
     Chart2.Series[1].clear;
     for i := 1 to 255 do
       HMassiv[i] := 0;
     max := 0;
     l := StrToInt(Edit1.Text);
     r := StrToInt(Edit2.Text);
     Chart2.Series[0].Clear;
     Chart2.Series[1].Clear;
     KoObr :=0.8;
     for s := l to r do       // ????? ????????? ???????
       if Spectr[s] > max then begin
         max := Spectr[s]; i := s; end;
     interval:=i-l;
     for s:=1 to 256 do
       HMassiv[s]:=Spectr[s];
     for s := 1 to l do
       HMassiv[s] := 0;
     for s := r to 255 do
        HMassiv[s] := 0;
     li:=i;
     ri:=i;
     rr:=-3;
     while rr<=interval  do
        begin
        Hmassiv[li]:=round((Hmassiv[li+1]+Hmassiv[li]+Hmassiv[li-1])/3);
        Hmassiv[li+1]:=Hmassiv[li];
        Hmassiv[li-1]:=Hmassiv[li];
        li:=li-3;
        Hmassiv[ri]:=round((Hmassiv[ri+1]+Hmassiv[ri]+Hmassiv[ri-1])/3);
        Hmassiv[ri+1]:=Hmassiv[ri];
        Hmassiv[ri-1]:=Hmassiv[ri];
        ri:=ri+3;
        rr:=rr+3;
        end;
     max:=0;
     pl:=0;
     pl := i+interval;
     for s := l to round(pl) do       // ????? ????????? ???????
        if HMassiv[s] > max then
          begin
              max := HMassiv[s]; i := s+1;
          end;
     for s:=l to i+interval do
      Chart2.Series[0].AddXY(s,HMassiv[s],'',clSilver);
     for s := l to i do     // ?????????? ?????? ? ??? ??????????? ??????
       if   max*KoObr >= HMassiv[s] then  i1 := s;
     for s := r downto i do
       if  Hmassiv[s]<=max*KoObr then i2 := s;
       for s:= i1 to i2 do
       pl:=pl+HMassiv[s];
      // Memo1.Lines.Add(IntToStr(round(pl)));
       //Memo1.Lines.Add(IntToStr(Hmassiv[40]) + IntToStr(HMassiv[48]));
       for s := l to r do
       if (s >= i1) and (s < i2) then
           Chart2.Series[0].AddXY(s,HMassiv[s],'',clGreen)
           else
           Chart2.Series[0].AddXY(s,Hmassiv[s],'',clSilver);
  {   for s:=l+1 to i-1 do
         Hmassiv[s]:=round((Hmassiv[s]+Hmassiv[s+1]+Hmassiv[s-1])/3);
     for s:=i+1 to (i+interval)-1 do
         Hmassiv[s]:=round((Hmassiv[s]+Hmassiv[s+1]+Hmassiv[s-1])/3); }


   //  Chart2.Series[0].Clear;
   //  Chart2.Series[0].SeriesColor := clRed;

     plosh := 0;
     for s := i1 to i2 do // ?????????? ???????
       plosh := plosh + HMassiv[s];
     y1 := 0; y2 := plosh/2;
     for s := i1 to i2 do begin // ??????????? ?????? ???????
       y1 := y1 + HMassiv[s];
       if y1 <= y2
       then i := s;
     end;
//     memo1.lines.add(floattostr(y1));
//     memo1.lines.add(floattostr(y2));
     label1.Caption:=IntToStr(i);
//     Str(i, sti); Str(i1, st1); Str(i2, st2);
//     Center.Caption := st1 + '  ' + st2 + '  ????? = ' + sti;
//     RecL.Level1Par := i;  // ??????? 1 ??????? ? ?????? ?????
  End;

end.
