unit RaRBM;
 {$APPTYPE CONSOLE}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, TeeProcs, TeEngine, Chart, Buttons, Math,
  //  LASDK
  ADC_Const, IADCDevice, IFactory, DllClient, VT_Drivers, ADC_Errors,
  Series, CheckLst, Mask;
Const
    MGain : array [1..8] of Integer = (1, 2, 5, 10, 20, 40, 100, 200);
    ChChan : array [1..10] of Integer = (1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
type
    Fon = record                                     //    
       Nfon: SmallInt;                               // 2 byte
       Comm: string[79];                             // 
       Date : array[1..4] of SmallInt;               // 8
       Time : array[1..4] of SmallInt;               // 8
       freq: integer;                                //  
       FGain : array [1..4] of SmallInt;             //  
       Level : array [1..4] of SmallInt;             //     
       Delta : SmallInt;                             //   
       Fon1, Fon2, Fon3, Fon4: array[1..600] of Integer; //
       TimF : array[1..600, 1..4] of word; // 1   
       spectr1, spectr2, spectr3, spectr4 : array [1..256] of SmallInt;
    end;

   Liv = record                                      //    
       Nliv: SmallInt;                               // 2 byte
       Comm: string[79];                             // 80
       Date: array[1..4] of SmallInt;                // 8
       Time: array[1..4] of SmallInt;                // 8
       RGain : array [1..6] of SmallInt;             //  
       DrvData1:   array[1..4096] of SmallInt;       // 8192
       DrvData2:   array[1..4096] of SmallInt;       // 8192
       DrvData3:   array[1..4096] of SmallInt;       // 8192
       DrvData4:   array[1..4096] of SmallInt;       // 8192
       DrvData5:   array[1..4096] of SmallInt;       // 8192
       DrvData6:   array[1..4096] of SmallInt;       // 8192
    end;                                             // 


type

  TForm1 = class(TForm)
    GroupBox2: TGroupBox;
    status: TStatusBar;
    Chart1: TChart;
    Timer1: TTimer;
    bStart1: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    ListBox1: TListBox;
    Label9: TLabel;
    bExit1: TButton;
    Series1: TLineSeries;
    bGain1: TButton;
    Chart2: TChart;
    Memo1: TMemo;
    MaskEdit1: TMaskEdit;
    Label17: TLabel;
    eComment: TEdit;
    Series4: TLineSeries;
    Label10: TLabel;
    bView: TButton;
    Label13: TLabel;
    Label16: TLabel;
    Series2: TLineSeries;
    Series0: TLineSeries;
    Nkadr: TLabel;
    Skadr: TLabel;
    KadrN: TLabel;
    bDown: TButton;
    bUp: TButton;
    bWrite: TButton;
    Series3: TLineSeries;
    Series5: TLineSeries;
    Series6: TLineSeries;
    Series7: TLineSeries;
    Series8: TLineSeries;
    Series9: TLineSeries;
    Series10: TLineSeries;
    Series11: TLineSeries;
    Series12: TLineSeries;
    Series13: TLineSeries;
    Series14: TLineSeries;
    Series15: TLineSeries;
    Series16: TLineSeries;
    Series17: TLineSeries;
    bWrite1: TButton;
    bViewRad: TButton;
    bForm2: TButton;
    Label1: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label2: TLabel;
    MaskEdit2: TMaskEdit;
    MaskEdit3: TMaskEdit;
    MaskEdit4: TMaskEdit;
    Label14: TLabel;
    Label15: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Button1: TButton;
    MaskEdit7: TMaskEdit;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Button2: TButton;
    Label20: TLabel;
    Label21: TLabel;
    lFGain1: TLabel;
    lFGain2: TLabel;
    lFGain3: TLabel;
    lFGain4: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    lRGain1: TLabel;
    lRGain2: TLabel;
    lRGain3: TLabel;
    lRGain6: TLabel;
    lRGain5: TLabel;
    lRGain4: TLabel;
    lTEAS: TLabel;
    eKadrRad: TEdit;
    bReadRad: TButton;
    eKadrFon: TEdit;
    bReadFon: TButton;
    procedure FormCreate(Sender: TObject);
    procedure bStart1Click(Sender: TObject);
    procedure Error(q:Integer);
    procedure EASTime;
    procedure NoError;
    procedure Timer1Timer(Sender: TObject);
    procedure ViewData;
    procedure bExit1Click(Sender: TObject);
    procedure bGain1Click(Sender: TObject);
    procedure dispers;
    procedure Otbor1;
    procedure Otbor2;
    procedure usr5;
    procedure usr3;
    procedure FonTime;
    procedure FileName;
    procedure FileNameEAS;
    procedure ParamSelect(Sender: TObject);
    procedure FileSelect1;
    procedure FileSelect2;
    procedure bViewClick(Sender: TObject);
    procedure ViewKadr;
    procedure ViewKadrEAS;
    procedure bDownClick(Sender: TObject);
    procedure bUpClick(Sender: TObject);
    procedure bWriteClick(Sender: TObject);
    procedure bWrite1Click(Sender: TObject);
    procedure bViewRadClick(Sender: TObject);
    procedure bForm2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure bReadRadClick(Sender: TObject);
    procedure bReadFonClick(Sender: TObject);


  private
    Fon1, Fon2 : array [1..1000000] of SmallInt;
    pADC1,pADC2,pADC3,pADC4,pADC5 : TIADCDevice;
    countFon1,countFon2,countFon3,countFon4 : Integer;
    sc1, sc2, NrecF, chkadr : Integer; //
    gear : integer; //     
    gear1 : integer;
    h, kofe : integer; //  , - 
    Factory:   TIFactory;
   // pADC :      TIADCDevice;
    afon, arad:         ADCParametersMEMORY;
    Base,q:      Integer;
    FFon: file of Fon;
    RecF: Fon;
    FLiv: file of Liv;
    RecL: Liv;
    DMA, IRQ:       Integer;
    NKadr1, Freq, Gain, Gain1, Nkan, Delta : Integer;   //, ,    
    ClbTime, Lev1 : Integer;       //  ,  
    BlockSize,BlockSize1, NrecL : Integer;    //  
    run, view, prn, view1,change,usr :       Boolean;  //
    BatN, zd : SmallInt;  //  ,   
    FNameEAS, St1 : string;
    DateTime, StopTime : TDateTime;
    hour,min,sec,ms,hourS,minS,secS,msS,OldSec,ClbSec  : word;
    Year,Month,Day: word;
    FileInfo : TSearchRec;
    FileList : array[0..150] of string[20];
    count, count1 : integer;   //
    List, prFon : boolean;
    channel : SmallInt;
    Gainn : array [1..6] of SmallInt;
    Secunda, JSec : SmallInt;
    nomercan : integer;// 

  public
        { Interruption handling procedure }
    FName : string;
    Gistr : boolean;
    GainR1, GainR2, GainR3, GainR4, GainR5, GainR6 : integer;
    GainF1, GainF2, GainF3, GainF4 : integer;
    GainReady : boolean;   //  
    Stroika : SmallInt;
    procedure GetDataBlock();
    procedure GetDataEAS();
    procedure SetGain;
    function Initialize: Boolean;
    procedure Stop;
   end;

var
    Form1:          TForm1;
//    procedure SetGain;
implementation

uses Unit2, GainSelect1;


{$R *.DFM}



procedure TForm1.FormCreate(Sender: TObject);
var u :integer;
begin
    Button1.Visible := false;
    Button2.Visible := false;
    usr:=false;
    Application.HintHidePause := -1;
    Gistr := false;
    status.SimpleText := '';            //   
    Chart2.Series[0].Clear;
    Timer1.Enabled := false;
    Base := 1;
    RecL.RGain[1] := 20; RecL.RGain[2] := 20; RecL.RGain[3] := 5;
    RecL.RGain[4] := 5; RecL.RGain[5] := 100; RecL.RGain[6] := 100;
    GainR1 := 20; GainR2 := 20; GainR3 := 5;
    GainR4 := 5; GainR5 := 100; GainR6 := 100;
    lRGain1.Caption := IntToStr(GainR1); lRGain2.Caption := IntToStr(GainR2);
    lRGain3.Caption := IntToStr(GainR3); lRGain4.Caption := IntToStr(GainR4);
    lRGain5.Caption := IntToStr(GainR5); lRGain6.Caption := IntToStr(GainR6);
    RecF.FGain[1] := 100; RecF.FGain[2] := 100;
    RecF.FGain[3] := 100; RecF.FGain[4] := 100;
    GainF1 := 100; GainF2 := 100; GainF3 := 100; GainF4 := 100;
    lFGain1.Caption := IntToStr(GainF1); lFGain2.Caption := IntToStr(GainF2);
    lFGain3.Caption := IntToStr(GainF3); lFGain4.Caption := IntToStr(GainF4);
    IRQ := 0; DMA := 1;
    Timer1.Interval := 1;
    BlockSize := 1000000;      //  
    BlockSize1 := 8192;
    Freq := 100000000;
    Nkan := 1; Delta := 90;
    run := false;
    Chart1.LeftAxis.Maximum := 128;
    Chart1.LeftAxis.Minimum := -128;
    chart1.BottomAxis.Minimum := 0;
    chart1.BottomAxis.Maximum := 4096;
    Chart2.LeftAxis.Automatic := true;
    count := 0; count1 := 0;
    gear1:=0;
    bForm2.Visible := false;
    for u := 1 to 6 do
      gainn[u] := 100;
end;

procedure TForm1.Stop;
begin
    //  
    if pADC1 <> nil then
    begin
        pADC1.Stop();
        pADC1.Release;
    end;
    if pADC2 <> nil then
    begin
        pADC2.Stop();
        pADC2.Release;
    end;
    if pADC3 <> nil then
    begin
        pADC3.Stop();
        pADC3.Release;
    end;
    if pADC4 <> nil then
    begin
        pADC4.Stop();
        pADC4.Release;
    end;
    if pADC5 <> nil then
    begin
        pADC5.Stop();
        pADC5.Release;
    end;
End;

function TForm1.Initialize: Boolean;
var
    alfa : integer;
    Client:   TDllClient;
    m_fFreq:  Single;
    z:        Integer;

Begin

    //  
    Client := TDllClient.Create;
    Factory := Client.LoadRegistered(CompanyNameDRV,
                                           ProductNameDRV,
                                           VersionNameDRV,
                                           'Lan10m8PCI',nil);
    if Factory = nil then
    begin
        Error(-10);
        result := false;
        Exit;
    end;

    //   

    pADC1 := Factory.Create('IADCDevice', nil);
    if pADC1 = nil then
    begin
        Error(-11);
        result := false;
        Exit;
    end;
    pADC2 := Factory.Create('IADCDevice', nil);
    if pADC2 = nil then
    begin
        Error(-11);
        result := false;
        Exit;
    end;

    pADC3 := Factory.Create('IADCDevice', nil);
    if pADC3 = nil then
    begin
        Error(-11);
        result := false;
        Exit;
    end;

    pADC4 := Factory.Create('IADCDevice', nil);
    if pADC4 = nil then
    begin
        Error(-11);
        result := false;
        Exit;
    end;

    pADC5 := Factory.Create('IADCDevice', nil);
    if pADC5 = nil then
    begin
        Error(-11);
        result := false;
        Exit;
    end;

     //  

    Client.Free;
    Base := 1;
    z:=pADC1.Setup(Base, DMA, IRQ, 0);
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;
    z:=pADC2.Setup(Base+1, DMA, IRQ, 0);
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;
    z:=pADC3.Setup(Base+2, DMA, IRQ, 0);
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;
    z:=pADC4.Setup(Base+3, DMA, IRQ, 0);
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;

    z:=pADC5.Setup(Base+4, DMA, IRQ, 0);
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;


    //      BusMaster/Slave
    //z := 1; //  BusMaster   pADC0 -  
    //pADC.Get(ADC_SET_DMA_BUSMASTER_ENABLE, @z);
    z:=1;
    pADC3.Get(ADC_SET_DMA_BUSMASTER_ENABLE, @z);  // 1   
 //   z := 0; //  Slave
    pADC1.Get(ADC_SET_DMA_BUSMASTER_ENABLE, @z);
    pADC2.Get(ADC_SET_DMA_BUSMASTER_ENABLE, @z);
  //  z := 0; //  Slave
    pADC4.Get(ADC_SET_DMA_BUSMASTER_ENABLE, @z);
    pADC5.Get(ADC_SET_DMA_BUSMASTER_ENABLE, @z);


    //       
    aFon.Create;
    with aFon do
    begin
        aFon.m_nStartOf := ADCPARAM_START_PROGRAMM;    //   
        aFon.m_nControl := ADC_CONTROL_ESW //   .
           or ADC_CONTROL_DIF0        //  0 
           or ADC_CONTROL_DIF1;        //  1 
        aFon.m_fFreq := Freq;                    //  , 
        aFon.m_nBufferSize := BlockSize;         //       
        aFon.m_nDelta[0] := Delta;               //  0- 
        aFon.m_nDelta[1] := Delta;               //  1- 
    end;

           //    
    aFon.m_nGain[0] := RecF.FGain[1];       //   0- 
    aFon.m_nGain[1] := RecF.FGain[2];       //   1- 
    z := pADC1.Init(ADC_INIT_MODE_INIT, @aFon, @m_fFreq);
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;

    aFon.m_nGain[0] := RecF.FGain[3];       //   0- 
    aFon.m_nGain[1] := RecF.FGain[4];       //   1- 
    z := pADC2.Init(ADC_INIT_MODE_INIT, @aFon, @m_fFreq);
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;

    //      

    aRad.Create;
    with aRad do
    begin
        aRad.m_nStartOf := ADCPARAM_START_COMP; //  . 
        aRad.m_nControl := ADC_CONTROL_ESW            //   .
                        or ADC_CONTROL_DIFS        //  
                        or ADC_CONTROL_DIF0        //  0 
                        or ADC_CONTROL_DIF1        //  1 
                        or ADC_CONTROL_SYNC_TTL    //. 
                        or ADC_CONTROL_SYNC_FRONT; // . .
        aRad.m_fFreq := Freq;                    //  , 
        aRad.m_nBufferSize := BlockSize1;         //       
        aRad.m_nBeforeHistory := 3;              //  
        aRad.m_nDelta[0] := -100;                   //  0- 
        aRad.m_nGain[0] := Gain1;                  //   0- 
        aRad.m_nDelta[1] := -100;                   //  1- 
        aRad.m_nGain[1] := Gain1;                  //   1- 
        aRad.m_nSyncLevel := 20;                   //  
    end;

    //   

    aRad.m_nGain[0] := RecL.RGain[1];       // 1   
    aRad.m_nGain[1] := RecL.RGain[2];
    z := pADC3.Init(ADC_INIT_MODE_INIT, @aRad, @m_fFreq);
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;

    aRad.m_nGain[0] := RecL.RGain[3];       // 2   
    aRad.m_nGain[1] := RecL.RGain[4];
    z := pADC4.Init(ADC_INIT_MODE_INIT, @aRad, @m_fFreq);
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;

    aRad.m_nGain[0] := RecL.RGain[5];       // 3   
    aRad.m_nGain[1] := RecL.RGain[6];
    z := pADC5.Init(ADC_INIT_MODE_INIT, @aRad, @m_fFreq);
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;

//    pADC1.ClearInterrupt;
//    pADC2.ClearInterrupt;
//    pADC3.ClearInterrupt;
//    pADC4.ClearInterrupt;
//    pADC5.ClearInterrupt;

    //  

    z := pADC1.Start;
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;

    z := pADC2.Start;
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;

    z := pADC3.Start;
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;

    z := pADC4.Start;
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;

    z := pADC5.Start;
    if z <= 0 then
    begin
        Error(z);
        result := false;
        Exit;
    end;

    Chart1.Series[0].Clear;     //  
    Chart1.Series[1].Clear;
    Chart1.Series[2].Clear;
    Chart1.Series[3].Clear;
    Chart1.Series[4].Clear;
    Chart1.Series[5].Clear;

    Chart2.Series[0].Clear;
    Chart2.Series[1].Clear;
    Chart2.Series[2].Clear;
    Chart2.Series[3].Clear;

    DateTime := Date;
    Form1.Label4.Caption := DateToStr(DateTime); //    
    DateTime := Time;  //   
    Form1.Label8.Caption := TimeToStr(DateTime);
    DecodeTime(DateTime, hour,min,sec,ms);
    ClbSec := ClbTime;
    min := min + minS;       //   
    if min >= 60 then begin min := min - 60; inc(hour); end;
    hour := hour + hourS;
    if hour >= 24 then hour := hour - 24;
    StopTime := EncodeTime(hour,min,sec,ms);
    result := true;
end;

Procedure TForm1.EasTime;  //       
  Begin
    DateTime := Time;
    DecodeTime(DateTime, hour,min,sec,ms);
    RecL.Time[1]:=hour;RecL.Time[2]:=min;
    RecL.Time[3]:=sec;RecL.Time[4]:=ms;
    Form1.lTEAS.Caption := TimeToStr(DateTime); //    
    Form1.Label6.Caption := TimeToStr(DateTime);
    DateTime := Date;
    DecodeDate(DateTime, Year, Month, Day);
    RecL.Date[1]:=Year;RecL.Date[2]:=Month;
    RecL.Date[3]:=Day;RecL.Date[4]:=DayOfWeek(DateTime);
    Form1.Label4.Caption := DateToStr(DateTime); //    
    inc(RecL.NLiv);  //   
    Form1.Label2.Caption := IntToStr(RecL.NLiv); //    
  End;

procedure TForm1.GetDataEAS();
var i,j,z : integer;
Begin
    pADC3.Get(ADC_GET_READY, @z);  //     -  
    if (z and 1) = 0 then Exit;
    EASTime;

    //     DMA( 1  )
    pADC3.GetData(ADC_DATA_MODE_DATAFROMDMA or
                    ADC_DATA_MODE_CONVERT2INT16 or ADC_DATA_MODE_DATACH0,
                    @RecL.DrvData1, BlockSize1 div 2, 0);
    //     DMA( 2  )
    pADC3.GetData(ADC_DATA_MODE_DATAFROMDMA or
                    ADC_DATA_MODE_CONVERT2INT16 or ADC_DATA_MODE_DATACH1,
                    @RecL.DrvData2, BlockSize1 div 2, 0);
//    pADC3.ClearInterrupt;
    z := pADC3.Start;        //  
    if z <= 0 then
    begin
        Error(z);
        Exit;
    end;

    //     DMA( 3  )
    pADC4.GetData(ADC_DATA_MODE_DATAFROMDMA or
                    ADC_DATA_MODE_CONVERT2INT16 or ADC_DATA_MODE_DATACH0,
                    @RecL.DrvData3, BlockSize1 div 2, 0);
    //     DMA( 4  )
    pADC4.GetData(ADC_DATA_MODE_DATAFROMDMA or
                    ADC_DATA_MODE_CONVERT2INT16 or ADC_DATA_MODE_DATACH1,
                    @RecL.DrvData4, BlockSize1 div 2, 0);
//    pADC4.ClearInterrupt;    //  
    z := pADC4.Start;        //  
    if z <= 0 then
      begin
        Error(z);
        Exit;
      end;

   //     DMA( 5  )
   pADC5.GetData(ADC_DATA_MODE_DATAFROMDMA or
                    ADC_DATA_MODE_CONVERT2INT16 or ADC_DATA_MODE_DATACH0,
                    @RecL.DrvData5, BlockSize1 div 2, 0);
   //     DMA( 6  )
   pADC5.GetData(ADC_DATA_MODE_DATAFROMDMA or
                    ADC_DATA_MODE_CONVERT2INT16 or ADC_DATA_MODE_DATACH1,
                    @RecL.DrvData6, BlockSize1 div 2, 0);
//   pADC5.ClearInterrupt;    //  
   z := pADC5.Start;        //  
   if z <= 0 then
     begin
         Error(z);
         Exit;
     end;
      // 
    AssignFile(FLiv,FNameEAS); Reset(FLiv); Seek(FLiv,NrecL);
    inc(NrecL);Write(FLiv,RecL);CloseFile(FLiv);
    Form1.KadrN.Caption:=IntToStr(NrecL);
    ViewData;
end;



procedure TForm1.GetDataBlock();    //     
var                                 // 2 : 1,2
    ready, z,x :     Integer;
    i, j : integer;

Begin
    x:=0;
    pADC3.Get(ADC_GET_READY, @x);  //     -  
    if (x and 1) = 1 then GetDataEAS();

    ready := 0;
    pADC1.Get(ADC_GET_READY, @Ready); //   1  
    if ready = 0 then exit;

    inc(gear1);
    pADC1.Stop;
             //     DMA( 0,  1 )
    pADC1.GetData(ADC_DATA_MODE_DATAFROMDMA or
                    ADC_DATA_MODE_CONVERT2INT16 or ADC_DATA_MODE_DATACH0,
                    @Fon1, BlockSize, 0);
    pADC1.GetData(ADC_DATA_MODE_DATAFROMDMA or
                    ADC_DATA_MODE_CONVERT2INT16 or ADC_DATA_MODE_DATACH1,
                    @Fon2, BlockSize, 0);
    z := pADC1.Start;        //  
    if z <= 0 then
        begin
            Error(z);
            Exit;
        end;

    x:=0;
    pADC3.Get(ADC_GET_READY, @x);  //     -  
    if (x and 1) = 1 then GetDataEAS();

    otbor1;      //      2 
    countFon1 := countFon1 + sc1;    //  
    countFon2 := countFon2 + sc2;
//    Chart1.Series[2].Clear;     //  
//    Chart1.Series[3].Clear;


    ready := 0;
    while ready = 0 do pADC2.Get(ADC_GET_READY, @Ready);   //  !
    pADC2.Stop;
             //     DMA( 0,  1 )
    pADC2.GetData(ADC_DATA_MODE_DATAFROMDMA or             //  !
                    ADC_DATA_MODE_CONVERT2INT16 or ADC_DATA_MODE_DATACH0,
                    @Fon1, BlockSize, 0);
    pADC2.GetData(ADC_DATA_MODE_DATAFROMDMA or             //  !
                    ADC_DATA_MODE_CONVERT2INT16 or ADC_DATA_MODE_DATACH1,
                    @Fon2, BlockSize, 0);
    z := pADC2.Start;        //   !  
    if z <= 0 then
        begin
            Error(z);
            Exit;
        end;

    x:=0;
    pADC3.Get(ADC_GET_READY, @x);
    if (x and 1) = 1 then GetDataEAS();

    otbor2;    //      2 
    countFon3 := countFon3 + sc1;   //  
    countFon4 := countFon4 + sc2;
//    Chart1.Series[2].Clear;     //  
//    Chart1.Series[3].Clear;

    inc(count1); //+1   
End;


Procedure TForm1.FonTime;  //       
var  i : integer;
  Begin
    DateTime := Time;
    DecodeTime(DateTime, hour,min,sec,ms);
    RecF.Time[1]:=hour;RecF.Time[2]:=min;
    RecF.Time[3]:=sec;RecF.Time[4]:=ms;
    Form1.Label6.Caption := TimeToStr(DateTime); //    
    DateTime := Date;
    DecodeDate(DateTime, Year, Month, Day);
    RecF.Date[1]:=Year;RecF.Date[2]:=Month;
    RecF.Date[3]:=Day;RecF.Date[4]:=DayOfWeek(DateTime);
    Form1.Label4.Caption := DateToStr(DateTime); //    
    RecF.Freq := Freq;
    for i := 1 to 256 do
       begin
          RecF.spectr1[i] := 0;
          RecF.spectr2[i] := 0;
          RecF.spectr3[i] := 0;
          RecF.spectr4[i] := 0;
       end;
    inc(RecF.Nfon);  //   
 //   Form1.Label6.Caption := IntToStr(RecF.Nfon); //    
  End;

procedure TForm1.dispers;          //  !!
var i : integer;
    u : real;
begin
  {y :=0;
  o:=0;
  u := 0 ;
  for i := 1 to 1048548 do
        //u := u + abs(ClbData[i]);
        //u := u + (90 - clbdata[i]);
        u:=u/1048548;
        //u := u+90;
        o:=round(u);
        o:=90;             //x 
      for i := 1 to 1048548 do
        y := y +sqr(o-ClbData [i]);
        y := y/(i-1);
        y := sqrt (y);  //  }
end;




Procedure TForm1.ViewData;        //   
Var j : integer;
Begin
        Chart1.Series[0].Clear;     //  
        Chart1.Series[1].Clear;
        Chart1.Series[2].Clear;
        Chart1.Series[3].Clear;
        Chart1.Series[4].Clear;
        Chart1.Series[5].Clear;
        //   
        for j := 1 to (BlockSize1 div 2) - 1 do
        begin
            //1 
            Chart1.Series[0].AddXY(j,RecL.DrvData1[j],'',Chart1.Series[0].SeriesColor);
           // 2 
            Chart1.Series[1].AddXY(j,RecL.DrvData2[j],'',Chart1.Series[1].SeriesColor);
            //3 
            Chart1.Series[2].AddXY(j,RecL.DrvData3[j],'',Chart1.Series[2].SeriesColor);
            //4 
            Chart1.Series[3].AddXY(j,RecL.DrvData4[j],'',Chart1.Series[3].SeriesColor);
            //5 
            Chart1.Series[4].AddXY(j,RecL.DrvData5[j],'',Chart1.Series[4].SeriesColor);
            //6 
            Chart1.Series[5].AddXY(j,RecL.DrvData6[j],'',Chart1.Series[5].SeriesColor);
{            //7 
            Chart1.Series[6].AddXY(j,RecL.DrvData7[j]+18,'',Chart1.Series[6].SeriesColor);
            //8 
            Chart1.Series[7].AddXY(j,RecL.DrvData8[j]+20,'',Chart1.Series[7].SeriesColor);
            //9 
            Chart1.Series[8].AddXY(j,RecL.DrvData9[j]+20,'',Chart1.Series[8].SeriesColor);
            //10 
            Chart1.Series[9].AddXY(j,RecL.DrvData10[j]+20,'',Chart1.Series[9].SeriesColor);
            //11 
            Chart1.Series[10].AddXY(j,RecL.DrvData11[j]+20,'',Chart1.Series[10].SeriesColor);
            //12 
            Chart1.Series[11].AddXY(j,RecL.DrvData12[j]+20,'',Chart1.Series[11].SeriesColor);  }
        end;
            Chart1.Series[6].AddXY(2577,127,'',Chart1.Series[6].SeriesColor);
            Chart1.Series[6].AddXY(2577,-128,'',Chart1.Series[6].SeriesColor);
        NoError;

{    hart2.Series[0].AddXY(count,RecF.Fon1[count],'',Chart2.Series[0].SeriesColor);
    Chart2.Series[1].AddXY(count,RecF.Fon2[count],'',Chart2.Series[1].SeriesColor);
    Chart2.Series[2].AddXY(count,RecF.Fon3[count],'',Chart2.Series[2].SeriesColor);
    Chart2.Series[3].AddXY(count,RecF.Fon4[count],'',Chart2.Series[3].SeriesColor);
    Chart2.Series[4].AddXY(count,RecF.Fon5[count],'',Chart2.Series[4].SeriesColor);
    Chart2.Series[5].AddXY(count,RecF.Fon6[count],'',Chart2.Series[5].SeriesColor); 
}
    End;

Procedure TForm1.FileSelect1;  //      
var x : integer;
    st: string[4];
Begin
   chart2.Series[0].Clear; chart2.series[1].Clear;
   chart2.series[2].Clear; chart2.series[3].Clear;
   FName := FileList[ListBox1.ItemIndex + 1];
   AssignFile(FFon,FName);      //  
   Reset(FFon); NrecF := 0;
   Read(FFon,RecF);
   chkadr := FileSize(FFon);
   CloseFile(FFon);
   Form1.Label2.Caption := '';
   Form1.Skadr.Caption := IntToStr(chkadr);
   St1 := IntToStr(RecF.Time[1]) + ':';
   St1 := St1 + IntToStr(RecF.Time[2]) + ':';
   St1 := St1 + IntToStr(RecF.Time[3]);
   Form1.Label8.Caption := St1;   //   
   St1 := IntToStr(RecF.Date[3]) + '-';
   St1 := St1 + IntToStr(RecF.Date[2]) + '-';
   St1 := St1 + IntToStr(RecF.Date[1]);
   Form1.Label4.Caption := St1;   //   
//   Form1.bGain2.Caption := IntToStr(RecF.Gain1);
//   Form1.MaskEdit1.Text := IntToStr(RecF.Level);
   st1:='';
   for x := 1 to 6 do
//       st1 :=st1+' '+ IntToStr(RecF.Gain[x]);
   Form1.eComment.Text:= St1;
   Delta := RecF.Delta;
 // eComment.Text := RecF.Comm;  // 
   Chart2.Series[0].Clear; Chart2.Series[1].Clear;
   Chart2.Series[2].Clear; Chart2.Series[3].Clear;
   Chart2.BottomAxis.Maximum := 600;
   Chart1.BottomAxis.Maximum := 600;
   chart2.LeftAxis.Automatic := true;
//   memo1.Lines.add (intToStr(recF.spectr1[50]));
//   Chart2.LeftAxis.Automatic := true;
//   Chart2.LeftAxis.Logarithmic := false;
//   chart2.Title.Text.SetText('');
//   chart2.LeftAxis.Title.Caption := '  ';
   Memo1.Lines.Clear;
   Memo1.Lines.add('1  - 2 * ()');
   Memo1.Lines.add('2  - 1 *  ()');
   Memo1.Lines.add('3  -  ()');
   Memo1.Lines.add('4  - 1 *  I ()');
//   Memo1.Lines.add('5  -  II ()');
//   Memo1.Lines.add('6  - 1 * (-)');

   ViewKadr;
   bForm2.Visible := true;
End;

Procedure TForm1.FileSelect2;
 //FNameEAS : String;
begin
    FNameEAS := FileList[ListBox1.ItemIndex + 1];
    AssignFile(FLiv,FNameEAS);
    Reset(FLiv);
    Read(FLiv,RecL); nkadr1 := FileSize(FLiv);
      CloseFile(FLiv);
    NRecL := 0;
    Form1.KadrN.Caption := IntToStr(nkadr1);
    Chart1.BottomAxis.Maximum := 4096;
    ViewKadrEAS;                                   //  1-  
    Form1.Label4.Caption := IntToStr(RecL.Date[3]) + '-' + IntToStr(RecL.Date[2])
                            + '-' + IntToStr(RecL.Date[1]);
    Form1.Label8.Caption := IntToStr(RecL.Time[1]) + ':' + IntToStr(RecL.Time[2])
                            + ':' + IntToStr(RecL.Time[3]); //  ,   

   //bNEAS.Enabled := true;                      //  
   //bUp1.Enabled := true; bDown1.Enabled := true;
  // Edit1.Enabled := true;
  // Edit2.Enabled := true;
  // bWrite1.Enabled := true;

end;

procedure TForm1.ViewKadrEAS;  //     .Rad
var j : integer;
Begin
    Chart1.Series[0].Clear;
    chart1.series[1].clear;
    Chart1.Series[2].Clear;
    chart1.series[3].clear;
    Chart1.Series[4].Clear;
    chart1.series[5].clear;
    Chart1.LeftAxis.Automatic:= false;
    Chart1.LeftAxis.Maximum := 127;
    Chart1.LeftAxis.Minimum := -128;
    AssignFile(FLiv,FNameEAS);
    Reset(FLiv);  seek(Fliv,NrecL);
    Read(FLiv,RecL); nkadr1 := FileSize(FLiv);
    CloseFile(FLiv);
    Form1.Label4.Caption := IntToStr(RecL.Date[3]) + '-' + IntToStr(RecL.Date[2])
                            + '-' + IntToStr(RecL.Date[1]);
    Form1.Label6.Caption := IntToStr(RecL.Time[1]) + ':' + IntToStr(RecL.Time[2])
                            + ':' + IntToStr(RecL.Time[3]);
    Form1.lTEAS.Caption := IntToStr(RecL.Time[1]) + ':' + IntToStr(RecL.Time[2])
                            + ':' + IntToStr(RecL.Time[3]);
    Form1.Label2.Caption := IntTostr(nKadr1);
    Form1.kadrN.Caption := IntToStr(nrecl+1);
    lRGain1.Caption := IntToStr(RecL.RGain[1]);  //  
    lRGain2.Caption := IntToStr(RecL.RGain[2]);
    lRGain3.Caption := IntToStr(RecL.RGain[3]);
    lRGain4.Caption := IntToStr(RecL.RGain[4]);
    lRGain5.Caption := IntToStr(RecL.RGain[5]);
    lRGain6.Caption := IntToStr(RecL.RGain[6]);
    if change then
                begin
                    case nomercan  of
                        1 :  for j := 1 to BlockSize1 div 2 do begin
                                 Chart1.Series[0].AddXY(j,RecL.drvData1[j],'',chart1.series[0].seriescolor);
                                 Chart1.Series[1].AddXY(j,RecL.drvData2[j]+20,'',chart1.series[1].seriescolor);
                                 end;
                        2 :  for j := 1 to BlockSize1 div 2 do begin
                                 Chart1.Series[2].AddXY(j,RecL.drvData3[j],'',chart1.series[2].seriescolor);
                                 Chart1.Series[3].AddXY(j,RecL.drvData4[j]+20,'',chart1.series[3].seriescolor);
                                 end;
                        3 :  for j := 1 to BlockSize1 div 2 do begin
                                 Chart1.Series[4].AddXY(j,RecL.drvData5[j],'',chart1.series[4].seriescolor);
                                 Chart1.Series[5].AddXY(j,RecL.drvData6[j]+20,'',chart1.series[5].seriescolor);
                                 end;
                end;
                end
   else
    for j := 1 to BlockSize1 div 2 do
        begin
            Chart1.Series[0].AddXY(j,RecL.drvData1[j],'',chart1.series[0].seriescolor);
            Chart1.Series[1].AddXY(j,RecL.drvData2[j]+10,'',chart1.series[1].seriescolor);
            Chart1.Series[2].AddXY(j,RecL.drvData3[j]+20,'',chart1.series[2].seriescolor);
            Chart1.Series[3].AddXY(j,RecL.drvData4[j]+30,'',chart1.series[3].seriescolor);
            Chart1.Series[4].AddXY(j,RecL.drvData5[j]+40,'',chart1.series[2].seriescolor);
            Chart1.Series[5].AddXY(j,RecL.drvData6[j]+50,'',chart1.series[3].seriescolor);
        end;
        Chart1.Series[6].AddXY(2577,127,'',Chart1.Series[6].SeriesColor);
        Chart1.Series[6].AddXY(2577,-128,'',Chart1.Series[6].SeriesColor);
End;

procedure TForm1.ViewKadr;   //     .fon
var j,k : integer;
    stb, stt : string;
Begin
   Chart2.Series[0].Clear;
   Chart2.Series[1].Clear;
   Chart2.Series[2].Clear;
   Chart2.Series[3].Clear;
   AssignFile(FFon,FName);Reset(FFon);Seek(FFon,NrecF);
   Read(FFon,RecF);CloseFile(FFon);                       //  
   Form1.Label4.Caption := IntToStr(RecF.Date[3]) + '-' + IntToStr(RecF.Date[2])
                            + '-' + IntToStr(RecF.Date[1]);
   Form1.Label6.Caption := IntToStr(RecF.Time[1]) + ':' + IntToStr(RecF.Time[2])
                            + ':' + IntToStr(RecF.Time[3]);
   Form1.KadrN.Caption :=  IntToStr(RecF.Nfon);  //  ,   
   lFGain1.Caption := IntToStr(RecF.FGain[1]);  //  
   lFGain2.Caption := IntToStr(RecF.FGain[2]);
   lFGain3.Caption := IntToStr(RecF.FGain[3]);
   lFGain4.Caption := IntToStr(RecF.FGain[4]);
   MaskEdit1.Text := IntToStr(RecF.Level[1]);   //   
   MaskEdit2.Text := IntToStr(RecF.Level[2]);
   MaskEdit3.Text := IntToStr(RecF.Level[3]);
   MaskEdit4.Text := IntToStr(RecF.Level[4]);
   if usr then usr5 else usr3;
   if change then
                begin
                    case nomercan  of
                        1 :  for j := 1 to 600 do Chart2.Series[0].AddXY(j,RecF.Fon1[j],'',Chart2.Series[0].SeriesColor);
                        2 :  for j := 1 to 600 do Chart2.Series[1].AddXY(j,RecF.Fon2[j],'',Chart2.Series[1].SeriesColor);
                        3 :  for j := 1 to 600 do Chart2.Series[2].AddXY(j,RecF.Fon3[j],'',Chart2.Series[2].SeriesColor);
                        4 :  for j := 1 to 600 do Chart2.Series[3].AddXY(j,RecF.Fon4[j],'',Chart2.Series[3].SeriesColor);
                end;
                end
   else
      begin
   for j := 1 to 600 do
      begin   //   
        Chart2.Series[0].AddXY(j,RecF.Fon1[j]+5,'',Chart2.Series[0].SeriesColor);
        Chart2.Series[1].AddXY(j,RecF.Fon2[j]+4,'',Chart2.Series[1].SeriesColor);
        Chart2.Series[2].AddXY(j,RecF.Fon3[j]+3,'',Chart2.Series[2].SeriesColor);
        Chart2.Series[3].AddXY(j,RecF.Fon4[j]+2,'',Chart2.Series[3].SeriesColor);
     end;
     end;
   Str(RecF.TimF[1,1]:2,stb); stt := stb + ':';
   Str(RecF.TimF[1,2]:2,stb); stt := stt + stb + ':';
   Str(RecF.TimF[1,3]:2,stb); stt := stt + stb;
   Label23.Caption := stt;
   if NrecF = chkadr-1 then
                        begin
                            for j := 1 to 600 do
                               if (RecF.Fon1 [j] = 0) and (RecF.Fon2[j] =0) and
                                (RecF.Fon3[j] =0)  and (RecF.Fon4[j] =0) 
                               then
                                  begin
                                      k := j;
                                      Str(RecF.TimF[k,1]:2,stb); stt := stb + ':';
                                      Str(RecF.TimF[k,2]:2,stb); stt := stt + stb + ':';
                                      Str(RecF.TimF[k,3]:2,stb); stt := stt + stb;
                                      Label24.Caption := stt;
                                      Exit;
                                  end;

                        end;
   Str(RecF.TimF[600,1]:2,stb); stt := stb + ':';
   Str(RecF.TimF[600,2]:2,stb); stt := stt + stb + ':';
   Str(RecF.TimF[600,3]:2,stb); stt := stt + stb;
   Label24.Caption := stt;
End;


procedure TForm1.bStart1Click(Sender: TObject);  //    Start
var x : integer;
    i,u : integer;
Begin

    Secunda := 0;
    JSec :=0;
    ListBox1.Items.Clear;
    chart1.Series[0].Clear;
    chart1.series[1].clear;
    chart1.Series[2].Clear;
    chart1.series[3].clear;
    chart1.Series[4].Clear;
    chart1.series[5].clear;
    chart2.Series[0].Clear;
    chart2.series[1].Clear;
    chart2.Series[2].Clear;
    chart2.series[3].Clear;

    Chart2.BottomAxis.Maximum := 600;
    Chart2.BottomAxis.Minimum := 0;
    Chart1.BottomAxis.Maximum := 4096;
    Chart1.LeftAxis.Maximum := 127;
    Chart1.LeftAxis.Minimum := -128;
    chart2.LeftAxis.Automatic := true;
    countFon1 := 0;
    countFon2 := 0 ;
    Form1.Skadr.Caption :='';
    Form1.Nkadr.Caption :='';
    eComment.Clear;    //   
    gear :=0;      //  - 
    gear1 := 0;
    h :=0;         // - 
    label6.caption := '';
    q:=0;
    Delta := 90;
    Base:=1;
    BlockSize := 1000000;      //    
    BlockSize1 := 8192;        //    
    Freq := 100000000;
    Nkan := 1;
    memo1.Lines.Clear;
    run := not run;
    if run then
    begin
        if Initialize then
           begin
            Timer1.Enabled := true;   //  
            bGain1.Enabled := false;
            bExit1.Enabled := false;
            bView.enabled := false;
            bViewRad.enabled := false;
            bWrite1.Enabled := false;
            bStart1.Caption := AnsiString('Stop');
            count := 0; count1 := 0;
            FilenameEAS; AssignFile(FLiv,FnameEAS); Rewrite(FLiv);
            FileName; AssignFile(FFon,FName); Rewrite(FFon);
            NRecF := 0; RecF.Nfon := 0;
            FonTime;
           end
        else
            run := not run;
    end
    else begin
        memo1.Lines.add ('-  - '+inttostr(count1 + count*25) );   //  - 
            ecomment.SetFocus;
            //run := not run;
            bGain1.Enabled := true;
            bExit1.Enabled := true;
            bView.enabled := true;
            bViewRad.enabled := true;
            bWrite1.Enabled := true;
            bStart1.Caption := AnsiString('Start');
            for x := count to 600 do begin
               RecF.Fon1[x] := 0;
               RecF.Fon2[x] := 0;
               RecF.Fon3[x] := 0;
               RecF.Fon4[x] := 0;
            end;
            AssignFile(FFon,FName); Reset(FFon); Seek(FFon,NrecF);
            inc(NrecF);Write(FFon,RecF);CloseFile(FFon);
            Form1.Skadr.Caption := IntToStr(NrecF);
        Stop;
        chart1.Series[0].Clear;
        chart1.series[1].clear;
        Timer1.Enabled := false;
        bGain1.Enabled := true;
        bExit1.Enabled := true;
        bStart1.Caption := AnsiString('Start');
    end;
End;

procedure TForm1.bExit1Click(Sender: TObject);  //   Exit
begin
    Close();
end;


procedure TForm1.Error(q:Integer);  //     
begin
    status.SimpleText := '';
    status.SimpleText := StrByErrCode(q);
    Stop;
    Timer1.Enabled := false;
    bStart1.Caption := AnsiString('Start');
end;

procedure TForm1.NoError;
begin
    status.SimpleText := '';
    status.SimpleText := '  ';
end;

Procedure TForm1.Timer1Timer(Sender: TObject);  //   
var x,j : Integer;

Begin
    if GainReady = true then SetGain;
    if run = false then exit;
    x :=0;
    j :=0;
    pADC3.Get(ADC_GET_READY, @x);
    if (x and 1) = 1 then GetDataEAS();

    GetDataBlock();      //   - 40   25 
    if count1 < 25 then Exit;  // 25  - 1 
    count1 := 0;
    inc(secunda);
    inc(count); // 1  
    DateTime := Time;
    DecodeTime(DateTime, hour,min,sec,ms);
    RecF.TimF[count,1] := hour; RecF.TimF[count,2] := min;
    RecF.TimF[count,3] := sec; RecF.TimF[count,4] := ms;
    RecF.Fon1[count] := countFon1;   // -   record
    RecF.Fon2[count] := countFon2;
    countFon1 := 0; countFon2 := 0;
    RecF.Fon3[count] := countFon3;
    RecF.Fon4[count] := countFon4;
    countFon3 := 0; countFon4 := 0;
    //ViewData;   //    
    Form1.KadrN.Caption := IntToStr(count);
    if Secunda >= 10 then
       begin
           Secunda :=0;
           for j := JSec to JSec+10 do
                begin   //   
                    Chart2.Series[0].AddXY(j,RecF.Fon1[j]+5,'',Chart2.Series[0].SeriesColor);
                    Chart2.Series[1].AddXY(j,RecF.Fon2[j]+4,'',Chart2.Series[1].SeriesColor);
                    Chart2.Series[2].AddXY(j,RecF.Fon3[j]+3,'',Chart2.Series[2].SeriesColor);
                    Chart2.Series[3].AddXY(j,RecF.Fon4[j]+2,'',Chart2.Series[3].SeriesColor);
                 end;
           JSec:=JSec+10;
       end;
    if count < 600 then Exit;  // 10  
    count := 0;
    JSec:=0;
    Chart2.Series[0].Clear;
    Chart2.Series[1].Clear;
    Chart2.Series[2].Clear;
    Chart2.Series[3].Clear;
    AssignFile(FFon,FName); Reset(FFon); Seek(FFon,NrecF); //  
    inc(NrecF);Write(FFon,RecF);CloseFile(FFon);
    FonTime;   //   .
//    Form1.Label6.Caption := TimeToStr(DateTime);
    Form1.Skadr.Caption := IntToStr(NrecF);
End;


Procedure TForm1.FileName;  //        
  Begin
    DateTime := Date; FName := '';
    DecodeDate(DateTime, Year, Month, Day);
    FName := IntToStr(Day)+ '_' + IntToStr(Month)+ '_';
    DateTime := Time;
    DecodeTime(DateTime, hour,min,sec,ms);
    FName := FName + IntToStr(hour)+ '_' + IntToStr(min)+ '.fon';
  End;

 Procedure TForm1.FileNameEAS;  //        
  Begin
    DateTime := Date; FNameEAS := '';
    DecodeDate(DateTime, Year, Month, Day);
    FNameEAS := IntToStr(Day)+ '_' + IntToStr(Month)+ '_';
    DateTime := Time;
    DecodeTime(DateTime, hour,min,sec,ms);
    FNameEAS := FNameEAS + IntToStr(hour)+ '_' + IntToStr(min)+ '.Rad';
  End;


Procedure TForm1.ParamSelect(Sender: TObject);  //    
  Begin
     Label9.Caption := AnsiString('');
     case BatN of
        1 : FileSelect2;  //FileSelect   .rad
 //       2 : GainSelect;
 //       3 : GainEASSelect;
        6 : FileSelect1;
 //       4 : ChChannSelect;
      end;
      bGain1.Enabled := true;
  End;



procedure TForm1.bWrite1Click(Sender: TObject);
var i : integer;
    stb,stt,sti,st1,st2,st3,st4,st5,st6 : string[12];
Begin
    prn := not prn;
    if prn then begin Memo1.Lines.Clear; bWrite1.Caption := ''; end
       else begin Memo1.Lines.Clear; bWrite1.Caption := ' ';
                   Exit;
            end;
    Form1.bWrite.Enabled := false;
    Memo1.Alignment := taLeftJustify;
    Memo1.Font.Name := 'Courier';
    Memo1.Lines.Add('  N       1    2    3    4    5    6 ');
    Memo1.Lines.Add('');
    for i := 1 to BlockSize1 div 2 do begin
       Str(i:4,sti);
       Str(RecL.DrvData1[i]:5,st1);Str(RecL.DrvData2[i]:5,st2);
       Str(RecL.DrvData3[i]:5,st3);Str(RecL.DrvData4[i]:5,st4);
       Str(RecL.DrvData5[i]:5,st5);Str(RecL.DrvData6[i]:5,st6);
       Memo1.Lines.Add(sti+'/ '+st1+st2+st3+st4+st5+st6);
       end;
End;


procedure TForm1.bGain1Click(Sender: TObject); //   
var s : integer;

begin
   GainR1 := RecL.RGain[1]; GainR2 := RecL.RGain[2]; GainR3 := RecL.RGain[3];
   GainR4 := RecL.RGain[4]; GainR5 := RecL.RGain[5]; GainR6 := RecL.RGain[6];
   GainF1 := RecF.FGain[1]; GainF2 := RecF.FGain[2];
   GainF3 := RecF.FGain[3]; GainF4 := RecF.FGain[4];
   GainReady := false;
   Timer1.Enabled := true;
   Form3.Show;
end;


procedure TForm1.bViewClick(Sender: TObject);//   
var
    s, k : integer;

Begin
    chart1.Series[0].Clear;
    chart1.series[1].clear;
    chart1.Series[2].Clear;
    chart1.series[3].clear;
    chart1.Series[4].Clear;
    chart1.series[5].clear;
    chart2.Series[0].Clear;
    chart2.series[1].Clear;
    chart2.Series[2].Clear;
    chart2.series[3].Clear;
    chart1.Title.Text.SetText(' ');
    Label23.Caption :='';
    Label24.Caption :='';
    Memo1.Lines.Clear;
    eComment.Clear; //    
   //memo1.lines.add(floattostr(m));
    list := false;
    view1:=false;
    prFon := true;
    bWrite1.Enabled := false;
    bWrite.Enabled := true;
    view := not view;
    if view = false then
       begin bView.Caption := AnsiString('View .fon');
         ListBox1.Items.Clear;
         Button2.Visible := false;
         Label9.Caption := AnsiString('');
         Form1.bForm2.Visible := false;
         Button1.Visible := false;
         Exit;
       end;
    Button2.Visible := true;
    Button1.Visible := true;
    //bView1.Caption := AnsiString('Stop');
    Label9.Caption := AnsiString(' ');
    ListBox1.Items.Clear; k := 0;                 //   
    s := FindFirst('*.fon',faAnyFile, FileInfo);  //   *.fon?
    if s = 0 then begin
         FileList[k] := FileInfo.Name; inc(k);
         repeat
            ListBox1.Items.Add(FileInfo.Name);    //   
            FileList[k] := FileInfo.Name; inc(k);
            s := FindNext(FileInfo);
         until s > 0;
    end;
    BatN := 6;

End;


procedure TForm1.Otbor1; //  
var
    o,u,i,up,x : integer;
Begin

   kofe:= strtoint(trim(maskedit1.Text));  // 1- 
   up:= 1; sc1 := 0; sc2 := 0;
   for u := 2 to BlockSize - 1 do
     if (90 - Fon1[u]) > kofe then    // .   
        if ((Fon1[u] <= Fon1[u+1]) and (Fon1[u] <= Fon1[u-1])) and
            (u - up > zd)
        then
        begin
            inc(sc1); up:=u;          //
            i:=90 - Fon1[u]; //
            inc (RecF.spectr1[i]); //- 

        end;
   up:= 1;
   kofe:= strtoint(trim(maskedit2.Text)); // 2- 
   for u := 2 to BlockSize - 1 do
     if (90 - Fon2[u]) > kofe then    // .   
        if ((Fon2[u] <= Fon2[u+1]) and (Fon2[u] <= Fon2[u-1])) and
            (u - up > zd)
        then
        begin
            inc(sc2); up:=u;          //
            i:=90 - Fon2[u]; //
            inc (RecF.spectr2[i]); //- 
        end;
    x:=0;
    pADC3.Get(ADC_GET_READY, @x);
    if (x and 1) = 1 then GetDataEAS();
End;


procedure TForm1.Otbor2; //  
var
    o,u,i,up,x : integer;
Begin
//label2.caption := Inttostr(gear1);
//   Label1.caption := inttostr(gear1);

   kofe:= strtoint(trim(maskedit3.Text));  /// 3- 
   up:= 1; sc1 := 0; sc2 := 0;
   for u := 2 to BlockSize - 1 do
     if (90 - Fon1[u]) > kofe then    // .   
        if ((Fon1[u] <= Fon1[u+1]) and (Fon1[u] <= Fon1[u-1])) and
            (u - up > zd)
        then
        begin
            inc(sc1); up:=u;          //
            i:=90 - Fon1[u]; //
            inc (RecF.spectr3[i]); //- 

        end;
   up:= 1;
   kofe:= strtoint(trim(maskedit4.Text));   // 4- 
   for u := 2 to BlockSize - 1 do
     if (90 - Fon2[u]) > kofe then    // .   
        if ((Fon2[u] <= Fon2[u+1]) and (Fon2[u] <= Fon2[u-1])) and
            (u - up > zd)
        then
        begin
            inc(sc2); up:=u;          //
            i:=90 - Fon2[u]; //
            inc (RecF.spectr4[i]); //- 
        end;
    x:=0;
    pADC3.Get(ADC_GET_READY, @x);
    if (x and 1) = 1 then GetDataEAS();
End;


procedure TForm1.bDownClick(Sender: TObject);
Begin
  if List then    //   View .Rad
            begin
                 Form1.KadrN.Caption := '';
                 if NRecL < 1 then begin
                 Form1.KadrN.Caption := '1'; Exit; end;
                 dec(NRecL);
                 ViewKadrEAS;

            end
          else   //   View .fon
            begin
               Form1.KadrN.Caption := '';
               if NRecF < 1 then begin
                    Form1.KadrN.Caption := '1'; Exit; end;
               dec(NRecF);
               ViewKadr;
            end;
End;

procedure TForm1.bUpClick(Sender: TObject);
Begin
  if list then begin   //   View .Rad
                    Form1.KadrN.Caption := '';
                    if NRecL >= nkadr1-1 then begin
                    Form1.KadrN.Caption := IntToStr(nKadr1); Exit; end;
                    inc(NRecL);
                    ViewKadrEAS;
                end

          else
             begin    //   View .fon
                Form1.KadrN.Caption := '';
                if NRecF >= chkadr - 1 then begin
                Form1.KadrN.Caption := IntToStr(chkadr); Exit; end;
                inc(NRecF);
                ViewKadr;
            end;
End;

procedure TForm1.bWriteClick(Sender: TObject);
var i : integer;
    stb,stt,sti,st1,st2,st3,st4,st5,st6 : string[12];
Begin
    prn := not prn;
    if prn then begin Memo1.Lines.Clear; bWrite.Caption := ''; end
       else begin Memo1.Lines.Clear; bWrite.Caption := '';
                   Memo1.Lines.add('1  - 2 * ()');
                   Memo1.Lines.add('2  -   ()');
                   Memo1.Lines.add('3  -  ()');
                   Memo1.Lines.add('4  -  I ()');
                   Exit;
            end;
    Memo1.Alignment := taLeftJustify;
    Memo1.Font.Name := 'Courier';
    Memo1.Lines.Add(' N             1    2    3    4');
    Memo1.Lines.Add('');
    for i := 1 to 600 do begin
       Str(i:3,sti);
       Str(RecF.TimF[i,1]:2,stb); stt := stb + ':';
       Str(RecF.TimF[i,2]:2,stb); stt := stt + stb + ':';
       Str(RecF.TimF[i,3]:2,stb); stt := stt + stb + ':';
       Str(RecF.TimF[i,4]:3,stb); stt := stt + stb + '   ';
       Str(RecF.Fon1[i]:5,st1);Str(RecF.Fon2[i]:5,st2);
       Str(RecF.Fon3[i]:5,st3);Str(RecF.Fon4[i]:5 ,st4);
       Memo1.Lines.Add(sti+'/ '+stt+st1+st2+st3+st4);
    end;

End;




procedure TForm1.bViewRadClick(Sender: TObject);
var
    s, k : integer;
begin
    Form1.bForm2.Visible := false;
    Button2.Visible := false;
    Button1.Visible := false;
    chart1.Series[0].Clear;
    chart1.series[1].clear;
    chart1.Series[2].Clear;
    chart1.series[3].clear;
    chart1.Series[4].Clear;
    chart1.series[5].clear;
    chart2.Series[0].Clear;
    chart2.series[1].Clear;
    chart2.Series[2].Clear;
    chart2.series[3].Clear;
    chart1.Title.Text.SetText('');
    eComment.Clear;
    list := true;
    view:= false;
    prFon := false;
    bWrite1.Enabled := true;
    bWrite.Enabled := false;
    Button1.Visible := true;
    view1 := not view1;
    if view1 = false then
       begin bViewRad.Caption := AnsiString('View .Rad');
         ListBox1.Items.Clear;
         Label9.Caption := AnsiString('');
         //Button1.Visible := true;
         Exit;
       end;
    Label9.Caption := AnsiString(' ');
    ListBox1.Items.Clear; k := 0;                 //   
    s := FindFirst('*.Rad',faAnyFile, FileInfo);  //   *.ob?
    if s = 0 then begin
         FileList[k] := FileInfo.Name; inc(k);
         repeat
            ListBox1.Items.Add(FileInfo.Name);    //   
            FileList[k] := FileInfo.Name; inc(k);
            s := FindNext(FileInfo);
         until s > 0;
    end;
    BatN := 1;
end;

procedure TForm1.bForm2Click(Sender: TObject);
   var x : smallint;
begin
   Gistr:=true;
   //Gistr := not Gistr;
   if Gistr then
       begin
        Form2.Show;
        Form2.bStopInt.Visible := false;
        //Label1.caption := Form1.FName;
        AssignFile(FFon,Form1.FName);      //  
        Reset(FFon); NrecF := 1;
        Read(FFon,RecF);
        Seek(FFon,NRecF);
        CloseFile(FFon);
        Form2.NameF := Fname;
        Form2.Chart2.Series[0].clear;
        form2.Label5.Caption := IntToStr(chkadr);
        for x := 1 to 225 do  //  .
                form2.Chart2.Series[0].AddXY(x,recF.spectr1[x],'',Chart2.Series[0].SeriesColor);
       end
       else
         Form2.Close();

end;



procedure TForm1.Button1Click(Sender: TObject);
Begin
nomercan:= strtoint(trim(maskedit7.Text));
if prFon then begin
   if nomercan > 4 then begin maskedit7.Text := '?!'; Exit; end;
   change := not change;
   if change then
             begin
                 Button1.Caption := '';
                 ViewKadr;
             end
          else
             begin
                Button1.Caption := '';
                ViewKadr;
             end;
end
else begin
   if nomercan > 3 then begin maskedit7.Text := '?!'; Exit; end;
   change := not change;
   if change then
             begin
                 Button1.Caption := '';
                 ViewKadrEAS;
             end
          else
             begin
                Button1.Caption := '';
                ViewKadrEAS;
             end;
   end;
End;

procedure TForm1.Button2Click(Sender: TObject);

begin
   usr:= not usr;
   if usr then begin Button2.Caption := '  5';ViewKadr; end
          else Button2.Caption := '  3'; ViewKadr;
end;

Procedure TForm1.usr3;
var
 sred1, sred2, sred3, sred4 : array[1..600] of integer;
 i,j : integer;
  begin
  Chart1.LeftAxis.Automatic:= true;
  Chart1.series[0].Clear;
  Chart1.series[2].Clear;
  Chart1.series[1].Clear;
  Chart1.series[3].Clear;

 for i := 1 to 600 do
 begin
    sred1[i]:=RecF.Fon1[i];
    sred2[i]:=RecF.Fon2[i];
    sred3[i]:=RecF.Fon3[i];
    sred4[i]:=RecF.Fon4[i];
 end;
 for i:=2 to 599 do
 begin
    sred1[i]:=Round((sred1[i-1]+sred1[i]+sred1[i+1])/3);
    sred2[i]:=Round((sred2[i-1]+sred2[i]+sred2[i+1])/3);
    sred3[i]:=Round((sred3[i-1]+sred3[i]+sred3[i+1])/3);
    sred4[i]:=Round((sred4[i-1]+sred4[i]+sred4[i+1])/3);
 end;
 if change then
                begin
                    case nomercan  of
                        1 :  for j := 1 to 600 do Chart1.Series[0].AddXY(j,sred1[j],'',Chart1.Series[0].SeriesColor);
                        2 :  for j := 1 to 600 do Chart1.Series[1].AddXY(j,sred2[j],'',Chart1.Series[1].SeriesColor);
                        3 :  for j := 1 to 600 do Chart1.Series[2].AddXY(j,sred3[j],'',Chart1.Series[2].SeriesColor);
                        4 :  for j := 1 to 600 do Chart1.Series[3].AddXY(j,sred4[j],'',Chart1.Series[3].SeriesColor);
                    end;
                end
   else
      begin
   for j := 1 to 600 do
      begin   //   
        Chart1.Series[0].AddXY(j,sred1[j],'',Chart1.Series[0].SeriesColor);
        Chart1.Series[1].AddXY(j,sred2[j],'',Chart1.Series[1].SeriesColor);
        Chart1.Series[2].AddXY(j,sred3[j],'',Chart1.Series[2].SeriesColor);
        Chart1.Series[3].AddXY(j,sred4[j],'',Chart1.Series[3].SeriesColor);
     end;
 end;
end;


procedure TForm1.bReadRadClick(Sender: TObject);
Var j : integer;
Begin
   j := StrToInt(trim(eKadrRad.Text));
   if (j > nkadr1) or (j < 1) then
          begin eKadrRad.Text := '!'; Exit end;
   NRecL := j;
   ViewKadrEAS;
End;


procedure TForm1.usr5;

var
 sred1, sred2, sred3, sred4 : array[1..600] of integer;
 i,j : integer;
  begin
  Chart1.LeftAxis.Automatic:= true;
  Chart1.series[0].Clear;
  Chart1.series[2].Clear;
  Chart1.series[1].Clear;
  Chart1.series[3].Clear;
  Chart1.series[4].Clear;
  Chart1.series[5].Clear;

 for i := 1 to 600 do
 begin
    sred1[i]:=RecF.Fon1[i];
    sred2[i]:=RecF.Fon2[i];
    sred3[i]:=RecF.Fon3[i];
    sred4[i]:=RecF.Fon4[i];
 end;
 for i:=3 to 598 do
 begin
   sred1[i]:=Round((sred1[i-2]+sred1[i-1]+sred1[i]+sred1[i+1]+sred1[i+2])/5);
   sred2[i]:=Round((sred2[i-2]+sred2[i-1]+sred2[i]+sred2[i+1]+sred2[i+2])/5);
   sred3[i]:=Round((sred3[i-2]+sred3[i-1]+sred3[i]+sred3[i+1]+sred3[i+2])/5);
   sred4[i]:=Round((sred4[i-2]+sred4[i-1]+sred4[i]+sred4[i+1]+sred4[i+2])/5);
 end;
 if change then
                begin
                    case nomercan  of
                        1 :  for j := 1 to 600 do Chart1.Series[0].AddXY(j,sred1[j],'',Chart1.Series[0].SeriesColor);
                        2 :  for j := 1 to 600 do Chart1.Series[1].AddXY(j,sred2[j],'',Chart1.Series[1].SeriesColor);
                        3 :  for j := 1 to 600 do Chart1.Series[2].AddXY(j,sred3[j],'',Chart1.Series[2].SeriesColor);
                        4 :  for j := 1 to 600 do Chart1.Series[3].AddXY(j,sred4[j],'',Chart1.Series[3].SeriesColor);
      end;
                end
   else
      begin
   for j := 1 to 600 do
      begin   //   
        Chart1.Series[0].AddXY(j,sred1[j],'',Chart1.Series[0].SeriesColor);
        Chart1.Series[1].AddXY(j,sred2[j],'',Chart1.Series[1].SeriesColor);
        Chart1.Series[2].AddXY(j,sred3[j],'',Chart1.Series[2].SeriesColor);
        Chart1.Series[3].AddXY(j,sred4[j],'',Chart1.Series[3].SeriesColor);
     end;
 end;
end;


Procedure TForm1.SetGain;
Begin
  RecL.RGain[1] := GainR1; RecL.RGain[2] := GainR2; RecL.RGain[3] := GainR3;
  RecL.RGain[4] := GainR4; RecL.RGain[5] := GainR5; RecL.RGain[6] := GainR6;
  lRGain1.Caption := IntToStr(GainR1); lRGain2.Caption := IntToStr(GainR2);
  lRGain3.Caption := IntToStr(GainR3); lRGain4.Caption := IntToStr(GainR4);
  lRGain5.Caption := IntToStr(GainR5); lRGain6.Caption := IntToStr(GainR6);
  RecF.FGain[1] := GainF1; RecF.FGain[2] := GainF2;
  RecF.FGain[3] := GainF3; RecF.FGain[4] := GainF4;
  lFGain1.Caption := IntToStr(GainF1); lFGain2.Caption := IntToStr(GainF2);
  lFGain3.Caption := IntToStr(GainF3); lFGain4.Caption := IntToStr(GainF4);

End;



procedure TForm1.bReadFonClick(Sender: TObject);
Var j : integer;
begin
   j := StrToInt(trim(eKadrFon.Text));
   if (j > chkadr) or (j < 1) then
          begin eKadrFon.Text := '!'; Exit end;
   NRecF := j;
   ViewKadr;
end;

END.



